import {select, range} from 'd3';

export const colorLegend = (parent, props) => {
  const {colorScale, circleRadius, legendSpacing, textOffset} = props; //Unpack parameters
  console.log(colorScale.domain())
  
  const gRect = parent.selectAll('rect')
  							.data([null]);
  gRect
  							.enter()
  							.append('rect')
  							.merge(gRect)
  								.attr('x', -10)
  								.attr('y', -10)
  								.attr('rx', circleRadius)
  								.attr('width', 130)
  								.attr('height', legendSpacing * colorScale.domain().length + legendSpacing/2)
  								.attr('class', 'legend');
  
  const groups      = parent.selectAll('.tick').data(colorScale.domain());
  const groupsEnter = groups.enter().append('g');
  groupsEnter.merge(groups) 
             		.attr('transform', (d, i) => `translate(0, ${i * legendSpacing })` ) ; 
  
  groups.exit()
  	    .remove();

  groupsEnter
    			 .append('circle')  
           .merge(groups.select('circle')) 

           	 .transition().duration(1000)
  					 .attr('fill',d => colorScale(d))
  					 .attr('stroke-width' , 5)
  					 .attr('r', circleRadius)
             .attr('cx', (d, i) => 0)
  
 					; 
 
  
  groupsEnter
    			 .append('text')
  						.attr('class', 'tick')
             	.attr('x', textOffset )
   						.attr('dy', '0.32em')
           .merge(groups.select('text'))  
    				 .text(d =>{return d;})
  					; 
 
 

 };